Subject: Re: [PATCH net-next] net: netdevsim: Support setting dev->perm_addr

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Wed, 05 Feb 2025 10:05:17 +0100

Jakub Kicinski <[email-masked]> writes:

> On Tue, 04 Feb 2025 12:20:56 +0100 Toke Høiland-Jørgensen wrote:
>> > netdevsim is not for user space testing. We have gone down the path
>> > of supporting random features in it already, and then wasted time trying
>> > to maintain them thru various devlink related perturbations, just to
>> > find out that the features weren't actually used any more.
>> >
>> > NetworkManager can do the HW testing using virtme-ng.  
>> 
>> Sorry if I'm being dense, but how would that work? What device type
>> would one create inside a virtme-ng environment that would have a
>> perm_addr set?
>
> virtme-ng is just a qemu wrapper. Qemu supports a bunch of emulated HW.

Hmm, okay, I'll pass the suggestion along.

>> > If you want to go down the netdevsim path you must provide a meaningful 
>> > in-tree test, but let's be clear that we will 100% delete both the test
>> > and the netdevsim functionality if it causes any issues.  
>> 
>> Can certainly add a test case, sure! Any preference for where to put it?
>> Somewhere in selftests/net, I guess, but where? rtnetlink.sh and
>> bpf_offload.py seem to be the only files currently doing anything with
>> netdevsim. I could add a case to the former?
>
> No preference, just an emphasis on _meaningful_.

OK, so checking that the feature works is not enough, in other words?

> Kernel supports loading OOT modules, too. I really don't want us
> to be in the business of carrying test harnesses for random pieces
> of user space code.

Right. How do you feel about Andrew's suggestion of just setting a
static perm_addr for netdevsim devices?

-Toke